#!/bin/bash

# Desc: Records gps data until midnight
# Author: Steven Baltakatei Sandoval; License: GPLv3+
# Usage: bkgpslog --output [output dir]

#==BEGIN Define script parameters==
## Logging Behavior parameters
BUFFER_TTL="60"; # time between file writes
SCRIPT_TTL="day"; # (day|hour)
TZ="UTC"; export TZ; # Default time zone; overridden by '--time-zone=[str]' option

PATH="$HOME/.local/bin:$PATH"   # Add "$(systemd-path user-binaries)" path in case apps saved there
SCRIPT_HOSTNAME=$(hostname)     # Save hostname of system running this script.
SCRIPT_VERSION="bkgpslog 0.1.0" # Define version of script.
DIR_TMP="/dev/shm/$(timeStart)..bkgpslog"     # Define working directory for temproary files

declare -Ag appRollCall # Associative array for storing app status
declare -Ag fileRollCall # Associative array for storing file status
declare -Ag dirRollCall # Associative array for storing dir status
declare -a recPubKeys # for processArguments function
declare recipients # for main function

#===BEGIN Declare local script functions===
checkapp() {
    # Desc: If arg is a command, save result in assoc array 'appRollCall'
    # Usage: checkapp arg1 arg2 arg3 ...
    # Input: global assoc. array 'appRollCall'
    # Output: adds/updates key(value) to global assoc array 'appRollCall'
    local returnState    
    #echo "DEBUG:$(date +%S.%N)..Starting checkapp function."
    #echo "DEBUG:args: $@"
    #echo "DEBUG:returnState:$returnState"

    #===Process Args===
    for arg in "$@"; do
	#echo "DEBUG:processing arg:$arg"
	if command -v "$arg" 1>/dev/null 2>&1; then # Check if arg is a valid command
	    appRollCall[$arg]="true";
	    #echo "DEBUG:appRollCall[$arg]:"${appRollCall[$arg]}
	    if ! [ "$returnState" = "false" ]; then returnState="true"; fi
	else
	    appRollCall[$arg]="false"; returnState="false";
	fi
    done
    
    #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
    #echo "DEBUG:evaluating returnstate. returnState:"$returnState

    #===Determine function return code===
    if [ "$returnState" = "true" ]; then
	#echo "DEBUG:checkapp returns true for $arg";
	return 0;
    else
	#echo "DEBUG:checkapp returns false for $arg";
	return 1;
    fi
} # Check that app exists
checkfile() {
    # Desc: If arg is a file path, save result in assoc array 'fileRollCall'
    # Usage: checkfile arg1 arg2 arg3 ...
    # Input: global assoc. array 'fileRollCall'
    # Output: adds/updates key(value) to global assoc array 'fileRollCall';
    # Output: returns 0 if app found, 1 otherwise
    local returnState

    #===Process Args===
    for arg in "$@"; do
	#echo "DEBUG:processing arg:$arg"
	if [ -f "$arg" ]; then
	    fileRollCall["$arg"]="true";
	    #echo "DEBUG:fileRollCall[\"$arg\"]:"${fileRollCall["$arg"]}
	    if ! [ "$returnState" = "false" ]; then returnState="true"; fi
	else
	    fileRollCall["$arg"]="false"; returnState="false";
	fi
    done

    #for key in "${!fileRollCall[@]}"; do echo "DEBUG:fileRollCall key [$key] is:${fileRollCall[$key]}"; done
    #echo "DEBUG:evaluating returnstate. returnState:"$returnState
    
    #===Determine function return code===
    if [ "$returnState" = "true" ]; then
	#echo "DEBUG:checkapp returns true for $arg";
	return 0;
    else
	#echo "DEBUG:checkapp returns false for $arg";
	return 1;
    fi
} # Check that file exists
checkdir() {
    # Desc: If arg is a dir path, save result in assoc array 'dirRollCall'
    # Usage: checkdir arg1 arg2 arg3 ...
    # Input: global assoc. array 'dirRollCall'
    # Output: adds/updates key(value) to global assoc array 'dirRollCall';
    # Output: returns 0 if app found, 1 otherwise
    local returnState

    #===Process Args===
    for arg in "$@"; do
	#echo "DEBUG:processing arg:$arg"
	if [ -d "$arg" ]; then
	    dirRollCall["$arg"]="true";
	    #echo "DEBUG:dirRollCall[\"$arg\"]:"${dirRollCall["$arg"]}
	    if ! [ "$returnState" = "false" ]; then returnState="true"; fi
	elif [ "$arg" = "" ]; then
	    dirRollCall["$arg"]="false"; returnState="false";
	else
	    returnState="false";
	fi
    done

    #for key in "${!dirRollCall[@]}"; do echo "DEBUG:dirRollCall key [$key] is:${dirRollCall[$key]}"; done
    #echo "DEBUG:evaluating returnstate. returnState:"$returnState
    
    #===Determine function return code===
    if [ "$returnState" = "true" ]; then
	#echo "DEBUG:checkapp returns true for $arg";
	return 0;
    else
	#echo "DEBUG:checkapp returns false for $arg";
	return 1;
    fi
} # Check that dir exists

# Yell, Die, Try Three-Fingered Claw technique
# Ref/Attrib: https://stackoverflow.com/a/25515370
yell() { echo "$0: $*" >&2; }
die() { yell "$*"; exit 111; }
try() { "$@" || die "cannot $*"; }

echoerr() {
    echo "$@" 1>&2; # Define stderr echo function.
} # Define stderr message function.
showUsage() {
    echoerr "USAGE:"
    echoerr "    bkgpslog [ options ]"
    echoerr
    echoerr "OPTIONS:"
    echoerr "    -h, --help"
    echoerr "            Display help information."
    echoerr
    echoerr "    --version"
    echoerr "            Display script version."
    echoerr
    echoerr "    -v, --verbose"
    echoerr "            Display debugging info."
    echoerr
    echoerr "    -e, --encrypt"
    echoerr "            Encrypt output."
    echoerr
    echoerr "    -r, --recipient [ pubkey string ]"
    echoerr "            Specify recipient."
    echoerr
    echoerr "    -o, --output [ directory ]"
    echoerr "            Specify output directory to save logs."
    echoerr
    echoerr "    -c, --compress"
    echoerr "            Compress output with gzip (before encryption if enabled)."
    echoerr
    echoerr "EXAMPLE: (bash script lines)"
    echoerr "/bin/bash bkgpslog -e -c \\"
    echoerr "-r age1mrmfnwhtlprn4jquex0ukmwcm7y2nxlphuzgsgv8ew2k9mewy3rs8u7su5 \\"
    echoerr "-r age1ala848kqrvxc88rzaauc6vc5v0fqrvef9dxyk79m0vjea3hagclswu0lgq \\"
    echoerr "-o ~/Sync/Location"
} # Display information on how to use this script.
showVersion() {
    echoerr "$SCRIPT_VERSION"
} # Display script version.
vbm() {
    # Usage: vbm "DEBUG:verbose message here"
    # Description: Prints verbose message ("vbm") to stderr if OPTION_VERBOSE is set to "true".
    # Input:
    #   - OPTION_VERBOSE  variable set by processArguments function. (ex: "true", "false")
    #   - "$@"            positional arguments fed to this function.
    # Output: stderr
    # Script function dependencies: echoerr
    # External function dependencies: echo
    # Last modified: 2020-04-11T23:57Z
    # Last modified by: Steven Baltakatei Sandoval
    # License: GPLv3+
    # Ref./Attrib:

    if [ "$OPTION_VERBOSE" = "true" ]; then
	FUNCTION_TIME=$(date --iso-8601=ns); # Save current time in nano seconds.
	echoerr "[$FUNCTION_TIME] ""$*"; # Display argument text.
    fi

    # End function
    return 0; # Function finished.
} # Verbose message display function.
processArguments() {
    while [ ! $# -eq 0 ]; do   # While number of arguments ($#) is not (!) equal to (-eq) zero (0).
	#echoerr "DEBUG:Starting processArguments while loop."
	#echoerr "DEBUG:Provided arguments are:""$*"
	case "$1" in
	    -h | --help) showUsage; exit 1;; # Display usage.
	    --version) showVersion; exit 1;; # Show version
	    -v | --verbose) OPTION_VERBOSE="true"; vbm "DEBUG:Verbose mode enabled.";; # Enable verbose mode.
	    -o | --output) if [ -d "$2" ]; then DIR_OUT="$2"; vbm "DEBUG:DIR_OUT:$DIR_OUT"; shift; fi ;; # Define output directory.
	    -e | --encrypt) OPTION_ENCRYPT="true"; vbm "DEBUG:Encrypted output mode enabled.";;
	    -r | --recipient) # Add 'age' recipient via public key string
		recPubKeys+=("$2"); vbm "pubkey added:""$2"; shift;;
	    -c | --compress) OPTION_COMPRESS="true"; vbm "DEBUG:Compressed output mode enabled.";;
	    -z | --time-zone) try setTimeZoneEV "$1";;
	    *) echoerr "ERROR: Unrecognized argument."; exit 1;; # Handle unrecognized options.
	esac
	shift
    done
} # Argument Processing
setTimeZoneEV(){
    # Desc: Set time zone environment variable TZ
    # Usage: setTimeZoneEV arg1
    # Input: arg1: 'date'-compatible timezone string (ex: "America/New_York")
    #        TZDIR env var (optional; default: "/usr/share/zoneinfo")
    # Output: exports TZ
    #         exit code 0 on success
    #         exit code 1 on incorrect number of arguments
    #         exit code 2 if unable to validate arg1
    # Depends: yell, printenv, bash 5
    # Tested on: Debian 10
    ARG1="$1"
    local tzDir returnState
    if ! [[ $# -eq 1 ]]; then
	yell "ERROR:Invalid argument count.";
	return 1;
    fi

    # Read TZDIR env var if available
    if printenv TZDIR 1>/dev/null 2>&1; then
	tzDir="$(printenv TZDIR)";
    else
	tzDir="/usr/share/zoneinfo";
    fi
    
    # Validate TZ string
    if ! [[ -f "$tzDir"/"$ARG1" ]]; then
	yell "ERROR:Invalid time zone argument.";
	return 2;
    else
    # Export ARG1 as TZ environment variable
	TZ="$ARG1" && export TZ && returnState="true";
    fi

    # Determine function return code
    if [ "$returnState" = "true" ]; then
	return 0;
    fi
} # Exports TZ environment variable
timeUntilNextDay(){
    # Desc: Report seconds until next day.
    # Output: stdout: integer seconds until next day
    # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
    # Usage: timeUntilNextDay
    # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
    local returnState TIME_CURRENT TIME_NEXT_DAY SECONDS_UNTIL_NEXT_DAY
    TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
    TIME_NEXT_DAY="$(date -d "$TIME_CURRENT next day" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
    SECONDS_UNTIL_NEXT_DAY="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
    if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then
	returnState="true";
    elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then
	returnState="WARNING_ZERO";
	yell "WARNING:Reported time until next day exactly zero.";
    elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then
	returnState="WARNING_NEGATIVE";
	yell "WARNING:Reported time until next day is negative.";
    fi

    try echo "$SECONDS_UNTIL_NEXT_DAY"; # Report
    
    #===Determine function return code===
    if [[ "$returnState" = "true" ]]; then
	return 0;
    elif [[ "$returnState" = "WARNING_ZERO" ]]; then
	return 1;
    elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
	return 2;
    fi
} # Report seconds until next day
timeUntilNextHour(){
    # Desc: Report seconds until next hour
    # Output: stdout: integer seconds until next hour
    # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
    # Usage: timeUntilNextHour
    # Usage: if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement"; exit 1; fi
    local returnState TIME_CURRENT TIME_NEXT_HOUR SECONDS_UNTIL_NEXT_HOUR
    TIME_CURRENT="$(date --iso-8601=seconds)"; # Produce `date`-parsable current timestamp with resolution of 1 second.
    TIME_NEXT_HOUR="$(date -d "$TIME_CURRENT next hour" --iso-8601=hours)"; # Produce `date`-parsable current time stamp with resolution of 1 second.
    SECONDS_UNTIL_NEXT_HOUR="$(( $(date +%s -d "$TIME_NEXT_HOUR") - $(date +%s -d "$TIME_CURRENT") ))"; # Calculate seconds until next hour (res. 1 second).
    if [[ "$SECONDS_UNTIL_NEXT_HOUR" -gt 0 ]]; then
	returnState="true";
    elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -eq 0 ]]; then
	returnState="WARNING_ZERO";
	yell "WARNING:Reported time until next hour exactly zero.";
    elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -lt 0 ]]; then
	returnState="WARNING_NEGATIVE";
	yell "WARNING:Reported time until next hour is negative.";
    fi

    try echo "$SECONDS_UNTIL_NEXT_HOUR"; # Report
    
    #===Determine function return code===
    if [[ "$returnState" = "true" ]]; then
	return 0;
    elif [[ "$returnState" = "WARNING_ZERO" ]]; then
	return 1;
    elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
	return 2;
    fi
} # Report seconds until next hour
dateTimeShort(){
    # Desc: Timestamp without separators (YYYYmmddTHHMMSS+zzzz)
    # Usage: dateTimeShort
    # Output: stdout: timestamp (ISO-8601, no separators)
    local TIME_CURRENT TIME_CURRENT_SHORT
    TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
    TIME_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)"; # Produce separator-less current timestamp with resolution 1 second.
    echo "$TIME_CURRENT_SHORT";
} # Get YYYYmmddTHHMMSS±zzzz
dateShort(){
    # Desc: Date without separators (YYYYmmdd)
    # Usage: dateShort
    # Output: stdout: date (ISO-8601, no separators)
    local TIME_CURRENT DATE_CURRENT_SHORT
    TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
    DATE_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%d)"; # Produce separator-less current date with resolution 1 day.
    echo "$DATE_CURRENT_SHORT";
} # Get YYYYmmdd
timeDuration(){
    # Desc: Output approximate time duration string before given time (default:current date)
    # Ref/Attrib: ISO-8601:2004(E), §4.4.4.2 Representations of time intervals by duration and context information
    # Note: "1 month" ("P1M") is assumed to be "30 days" (see ISO-8601:2004(E), §2.2.1.2)
    # Usage: timeDuration [arg1] ([arg2])
    # Input: arg1: seconds as base 10 integer >= 0  (ex: 3601)
    #        arg2: precision level (optional; default=2)
    # Output: stdout: ISO-8601 duration string (ex: "P1H1S", "P2Y10M15DT10H30M20S")
    # Example: 'timeDuration 111111 3' yields 'P1DT6H51M'
    # Depends: date 8 (gnucoreutils)
    local returnState fullHours fullMinutes fullSeconds;
    ARG1="$1";
    ARG2="$2";
    precision=2; # set default precision
    returnState="true"; # set default return state

    # Check that between one and two arguments is supplied
    if ! { [[ $# -ge 1 ]] && [[ $# -le 2 ]]; }; then
	yell "ERROR:Invalid number of arguments:$# . Exiting.";
	returnState="ERROR_INPUT"; fi

    # Check that arg1 provided
    if [[ $# -ge 1 ]]; then
	# Check that arg1 is a positive integer
	if [[ "$ARG1" =~ ^[[:digit:]]+$ ]]; then
   	    arg1Valid="true";
	else
	    yell "ERROR:ARG1 not a digit.";
	    returnState="ERROR_INPUT";
	    arg1Valid="false";
	fi
    else
	yell "ERROR:No argument provided. Exiting.";
	exit 1;
    fi

    # Consider whether arg2 was provided
    if  [[ $# -eq 2 ]]; then
	# Check that the second arg is a positive integer
	if [[ "$ARG2" =~ ^[[:digit:]]+$ ]] && [[ "ARG2" -gt 0 ]]; then
	arg2Valid="true";
	precision="$ARG2";
	else
	    yell "ERROR:ARG2 not a positive integer. (is $ARG2 ). Leaving early.";
	    returnState="ERROR_INPUT";
	    arg2Valid="false";
	fi;
    else
	arg2Valid="false";
    fi;
    
    remainder="$ARG1" ; # seconds
    ## Calculate full years Y, update remainder
    fullYears=$(( remainder / (365*24*60*60) ));
    remainder=$(( remainder - (fullYears*365*24*60*60) ));
    ## Calculate full months M, update remainder
    fullMonths=$(( remainder / (30*24*60*60) ));
    remainder=$(( remainder - (fullMonths*30*24*60*60) ));
    ## Calculate full days D, update remainder
    fullDays=$(( remainder / (24*60*60) ));
    remainder=$(( remainder - (fullDays*24*60*60) ));
    ## Calculate full hours H, update remainder
    fullHours=$(( remainder / (60*60) ));
    remainder=$(( remainder - (fullHours*60*60) ));
    ## Calculate full minutes M, update remainder
    fullMinutes=$(( remainder / (60) ));
    remainder=$(( remainder - (fullMinutes*60) ));
    ## Calculate full seconds S, update remainder
    fullSeconds=$(( remainder / (1) ));
    remainder=$(( remainder - (remainder*1) ));
    ## Check which fields filled
    if [[ $fullYears -gt 0 ]]; then hasYears="true"; else hasYears="false"; fi
    if [[ $fullMonths -gt 0 ]]; then hasMonths="true"; else hasMonths="false"; fi
    if [[ $fullDays -gt 0 ]]; then hasDays="true"; else hasDays="false"; fi
    if [[ $fullHours -gt 0 ]]; then hasHours="true"; else hasHours="false"; fi
    if [[ $fullMinutes -gt 0 ]]; then hasMinutes="true"; else hasMinutes="false"; fi
    if [[ $fullSeconds -gt 0 ]]; then hasSeconds="true"; else hasSeconds="false"; fi
    
    ## Determine which fields to display (see ISO-8601:2004 §4.4.3.2)
    witherPrecision="false"
    
    ### Years
    if $hasYears && [[ $precision -gt 0 ]]; then
	displayYears="true";
	witherPrecision="true";
    else
	displayYears="false";
    fi;
    if $witherPrecision; then ((precision--)); fi;
    
    ### Months
    if $hasMonths && [[ $precision -gt 0 ]]; then
	displayMonths="true";
	witherPrecision="true";
    else
	displayMonths="false";
    fi;
    if $witherPrecision && [[ $precision -gt 0 ]]; then
	displayMonths="true";
    fi;
    if $witherPrecision; then ((precision--)); fi;

    ### Days
    if $hasDays && [[ $precision -gt 0 ]]; then
	displayDays="true";
	witherPrecision="true";
    else
	displayDays="false";
    fi;
    if $witherPrecision && [[ $precision -gt 0 ]]; then
	displayDays="true";
    fi;
    if $witherPrecision; then ((precision--)); fi;

    ### Hours
    if $hasHours && [[ $precision -gt 0 ]]; then
	displayHours="true";
	witherPrecision="true";
    else
	displayHours="false";
    fi;
    if $witherPrecision && [[ $precision -gt 0 ]]; then
	displayHours="true";
    fi;
    if $witherPrecision; then ((precision--)); fi;

    ### Minutes
    if $hasMinutes && [[ $precision -gt 0 ]]; then
	displayMinutes="true";
	witherPrecision="true";
    else
	displayMinutes="false";
    fi;
    if $witherPrecision && [[ $precision -gt 0 ]]; then
	displayMinutes="true";
    fi;
    if $witherPrecision; then ((precision--)); fi;

    ### Seconds

    if $hasSeconds && [[ $precision -gt 0 ]]; then
	displaySeconds="true";
	witherPrecision="true";
    else
	displaySeconds="false";
    fi;
    if $witherPrecision && [[ $precision -gt 0 ]]; then
	displaySeconds="true";
    fi;
    if $witherPrecision; then ((precision--)); fi;



    ## Determine whether or not the "T" separator is needed to separate date and time elements
    if ( $displayHours || $displayMinutes || $displaySeconds); then
	displayDateTime="true"; else displayDateTime="false"; fi
    
    ## Construct duration output string
    OUTPUT="P"
    if $displayYears; then
	OUTPUT=$OUTPUT$fullYears"Y"; fi
    if $displayMonths; then
	OUTPUT=$OUTPUT$fullMonths"M"; fi
    if $displayDays; then
	OUTPUT=$OUTPUT$fullDays"D"; fi
    if $displayDateTime; then
	OUTPUT=$OUTPUT"T"; fi
    if $displayHours; then
	OUTPUT=$OUTPUT$fullHours"H"; fi
    if $displayMinutes; then
	OUTPUT=$OUTPUT$fullMinutes"M"; fi
    if $displaySeconds; then
	OUTPUT=$OUTPUT$fullSeconds"S"; fi

    ## Output duration string to stdout
    if [[ "$returnState" = "true" ]]; then echo "$OUTPUT"; fi

    #===Determine function return code===
    if [ "$returnState" = "true" ]; then
	return 0;
    else
	echo "$returnState" 1>&2;
	return 1;
    fi

} # Get duration (ex: PT10M4S )
displayMissing() {
    # Desc: Displays missing apps, files, and dirs
    # Usage: displayMissing
    # Input: associative arrays: appRollCall, fileRollCall, dirRollCall
    # Output: stderr messages
    #==BEGIN Display errors==
    #===BEGIN Display Missing Apps===
    missingApps="Missing apps  :"
    #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
    for key in "${!appRollCall[@]}"; do
	value="${appRollCall[$key]}"
	if [ "$value" = "false" ]; then
	    #echo "DEBUG:Missing apps: $key => $value";
	    missingApps="$missingApps""$key "
	    appMissing="true"
	fi
    done
    if [ "$appMissing" = "true" ]; then  # Only indicate if an app is missing.
	echo "$missingApps" 1>&2;
    fi
    #===END Display Missing Apps===

    #===BEGIN Display Missing Files===
    missingFiles="Missing files:"
    #for key in "${!fileRollCall[@]}"; do echo "DEBUG:$key => ${fileRollCall[$key]}"; done
    for key in "${!fileRollCall[@]}"; do
	value="${fileRollCall[$key]}"
	if [ "$value" = "false" ]; then
	    #echo "DEBUG:Missing files: $key => $value";
	    missingFiles="$missingFiles""$key "
	    fileMissing="true"
	fi
    done
    if [ "$fileMissing" = "true" ]; then  # Only indicate if an app is missing.
	echo "$missingFiles" 1>&2;
    fi
    #===END Display Missing Files===

    #===BEGIN Display Missing Directories===
    missingDirs="Missing dirs:"
    #for key in "${!dirRollCall[@]}"; do echo "DEBUG:$key => ${dirRollCall[$key]}"; done
    for key in "${!dirRollCall[@]}"; do
	value="${dirRollCall[$key]}"
	if [ "$value" = "false" ]; then
	    #echo "DEBUG:Missing dirs: $key => $value";
	    missingDirs="$missingDirs""$key "
	    dirMissing="true"
	fi
    done
    if [ "$dirMissing" = "true" ]; then  # Only indicate if an dir is missing.
	echo "$missingDirs" 1>&2;
    fi
    #===END Display Missing Directories===

    #==END Display errors==
} # Display missing apps, files, dirs
setScriptTTL() {
    #Desc: Sets script TTL
    #Usage: setScriptTTL arg1
    #Input: arg1: "day" or "hour"
    #Output: scriptTTL
    #Depends: timeUntilNextHour or timeUntilNextDay
    local ARG1
    ARG1="$1"
    if [[ "$ARG1" = "day" ]]; then
	    # Set script lifespan to end at start of next day
	if ! scriptTTL="$(timeUntilNextDay)"; then
	    if [[ "$scriptTTL" -eq 0 ]]; then
	    ((scriptTTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
	    else
	    yell "ERROR: timeUntilNextDay exit code $?"; exit 1;
	    fi;
	fi;
    elif [[ "$ARG1" = "hour" ]]; then
	# Set script lifespan to end at start of next hour
	if ! scriptTTL="$(timeUntilNextHour)"; then
	    if [[ "$scriptTTL" -eq 0 ]]; then
		((scriptTTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
	    else
		yell "ERROR: timeUntilNextHour exit code $?"; exit 1;
	    fi;
	fi;
    else
	yell "ERROR:Invalid argument for setScriptTTL function."; exit 1;
    fi
} # Seconds until next (day|hour).
main() {
    processArguments "$@" # Process arguments.

    # Set output encryption and compression option strings
    if [[ "$OPTION_ENCRYPT" = "true" ]]; then # Check if encryption option active.
	if checkapp age; then # Check that age is available.
	    for pubkey in "${recPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
		vbm "DEBUG:Testing pubkey string:$pubkey"
		if echo "butts" | age -a -r "$pubkey" 1>/dev/null; then
		    # Form age recipient string
		    recipients="$recipients""-r $pubkey ";
		    vbm "Added pubkey for forming age recipient string:""$pubkey";
		    vbm "DEBUG:recipients:""$recipients";
		else
		    yell "ERROR:Exit code ""$?"". Invalid recipient pubkey string. Exiting."; exit 1;
		fi
	    done
	    vbm "DEBUG:Finished processing recPubKeys array";
	    # Form age command string
	    CMD_ENCRYPT="age ""$recipients ";
	    CMD_ENCRYPT_SUFFIX=".age";
	else
	    yell "ERROR:Encryption enabled but \"age\" not found. Exiting."; exit 1;
	fi
    else
	CMD_ENCRYPT="tee /dev/null ";
	CMD_ENCRYPT_SUFFIX="";
	vbm "DEBUG:Encryption not enabled."
    fi
    if [[ "$OPTION_COMPRESS" = "true" ]]; then # Check if compression option active
	if checkapp gzip; then # Check if gzip available
	    CMD_COMPRESS="gzip ";
	    CMD_COMPRESS_SUFFIX=".gz";
	else
	    yell "ERROR:Compression enabled but \"gzip\" not found. Exiting."; exit 1;
	fi
    else
	CMD_COMPRESS="tee /dev/null ";
	CMD_COMPRESS_SUFFIX="";
	vbm "DEBUG:Compression not enabled."
    fi

    # Check that critical apps and dirs are available, displag missing ones.
    if ! checkapp gpspipe tar && ! checkdir "$DIR_OUT" "/dev/shm"; then
	yell "ERROR:Critical components missing.";
	displayMissing; yell "Exiting."; exit 1; fi

    # Set script lifespan
    setScriptTTL "$SCRIPT_TTL";

    # File name substring: encoded bufferTTL
    bufferTTL_STR="$(timeDuration $BUFFER_TTL)";

    # Init temp working dir
    try mkdir "$DIR_TMP" && vbm "DEBUG:Working dir creatd at:$DIR_TMP"

    # Initialize 'tar' archive
    ## Define output tar path (note: each day gets *one* tar file (Ex: "20200731..hostname_location.[.gpx.gz].tar"))
    PATHOUT_TAR="$DIR_OUT"/"$(dateShort)".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar 
    ## Write bkgpslog version to DIR_TMP/VERSION
    echo "$0"" Version:""$SCRIPT_VERSION" >> "$DIR_TMP/VERSION" && vbm "DEBUG:VERSION created."
    ## Create empty tar archive at PATHOUT_TAR
    try tar --create --directory="$DIR_TMP" --file="$PATHOUT_TAR" --files-from=/dev/null && vbm "DEBUG:bufferRam.tar created."
    ## Append VERSION file to PATHOUT_TAR
    try tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "VERSION" && vbm "DEBUG:VERSION added to $PATHOUT_TAR"
    
    # Record gps data until script lifespan ends
    declare debugCounter; debugCounter="0"; # set debug counter
    timeStart=$(dateTimeShort); # Note start time
    while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
	# Determine file paths (time is start of buffer period)
	FILEOUT_BASENAME="$timeStart""--""$bufferTTL_STR""..""$SCRIPT_HOSTNAME""_location" ; # ISO-8601 YYYYmmddTHHMMSS+zzP[$bufferTTL]S
	## Files saved to tmpfs memory (DIR_TMP)
	PATHOUT_NMEA="$DIR_TMP"/"$FILEOUT_BASENAME".nmea"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" ; 
	PATHOUT_GPX="$DIR_TMP"/"$FILEOUT_BASENAME".gpx"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" ;
	PATHOUT_KML="$DIR_TMP"/"$FILEOUT_BASENAME".kml"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" ;
	## Files saved to disk (DIR_OUT)
	### one file per day (Ex: "20200731..hostname_location.[.gpx.gz].tar")
	PATHOUT_TAR="$DIR_OUT"/"$(dateShort)".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar 
	# Define GPS conversion commands
	CMD_CONV_NMEA="tee /dev/null " ; # tee as passthrough
	CMD_CONV_GPX="gpsbabel -i nmea -f - -o gpx -F - " ; # convert NMEA to GPX
	CMD_CONV_KML="gpsbabel -i nmea -f - -o kml -F - " ; # convert NMEA to KML
	# Fill Bash variable buffer
	bufferBash="$(timeout "$BUFFER_TTL""s" gpspipe -r)"; # Record gpspipe nmea data to buffer for bufferTTL seconds
	# Process bufferBash, save secured chunk set to DIR_TMP
	echo "$bufferBash" | $CMD_CONV_NMEA | $CMD_COMPRESS | $CMD_ENCRYPT > "$PATHOUT_NMEA" & # Create NMEA file (secured if requested)
	echo "$bufferBash" | $CMD_CONV_GPX  | $CMD_COMPRESS | $CMD_ENCRYPT > "$PATHOUT_GPX" & # Create GPX file (secured if requested)
	echo "$bufferBash" | $CMD_CONV_KML  | $CMD_COMPRESS | $CMD_ENCRYPT > "$PATHOUT_KML" & # Create KML file (secured if requested)
	vbm "DEBUG:Completed buffer session $debugCounter ." 1>&2;
	# Append each secured chunk in memory dir (DIR_TMP) to file on disk (PATHOUT_TAR in DIR_OUT)
	try tar --append --directory="$(dirname $"PATHOUT_NMEA")" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_NMEA")" && \
	    vbm "DEBUG:Appended NMEA location data $PATHOUT_NMEA to $PATHOUT_TAR";
	try tar --append --directory="$(dirname $"PATHOUT_GPX")" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_GPX")" && \
	    vbm "DEBUG:Appended GPX location data $PATHOUT_GPX to $PATHOUT_TAR";
	try tar --append --directory="$(dirname $"PATHOUT_KML")" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_KML")" && \
	    vbm "DEBUG:Appended KML location $PATHOUT_KML to $PATHOUT_TAR";
	# Remove secured chunks from DIR_TMP
	try rm "$PATHOUT_NMEA" "$PATHOUT_NMEA" "$PATHOUT_NMEA";
	# Reset buffer and filenames
	unset bufferBash FILEOUT_BASENAME PATHOUT_NMEA PATHOUT_GPX PATHOUT_KML PATHOUT_TAR;
	((debugCounter++))
    done
} # Main function.
#===END Declare local script functions===
#==END Define script parameters==


#==BEGIN Perform work and exit==
main "$@" # Run main function.
exit 0;
#==END Perform work and exit==